/*
 File: lalr1_dp2sym.cpp
 Date and Time: Mon Oct 13 18:18:14 2014 
*/
#include "lalr1_dp2.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_lalr1_dp2;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Clalr1_dp2::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rlalr1_dp2_:{
       Rlalr1_dp2* sym;
     if(re->rule_ == 0){
       sym = new Rlalr1_dp2(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlalr1_dp2*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_RS1_:{
       RS1* sym;
     if(re->rule_ == 0){
       sym = new RS1(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS1*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_RS1_:{
       RS1* sym;
     if(re->rule_ == 0){
       sym = new RS1(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS1*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs3_RS1_:{
       RS1* sym;
     if(re->rule_ == 0){
       sym = new RS1(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS1*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_RB_:{
       RB* sym;
     if(re->rule_ == 0){
       sym = new RB(parser__);
       re->rule_ = sym;
     }else{
       sym = (RB*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_RC_:{
       RC* sym;
     if(re->rule_ == 0){
       sym = new RC(parser__);
       re->rule_ = sym;
     }else{
       sym = (RC*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_RD_:{
       RD* sym;
     if(re->rule_ == 0){
       sym = new RD(parser__);
       re->rule_ = sym;
     }else{
       sym = (RD*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs1_RE_:{
       RE* sym;
     if(re->rule_ == 0){
       sym = new RE(parser__);
       re->rule_ = sym;
     }else{
       sym = (RE*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    default: return;
   }
}
